﻿using System;
using System.Collections.Generic;
using TSLab.DataSource;
using TSLab.Script;
using TSLab.Script.Handlers;

namespace TSLab.Indicators
{
    
    [HandlerCategory("Ivan")]
    public class DeltaIvan : IBar2DoubleHandler
    {
        public IList<double> Execute(ISecurity source)
        {
            int count = source.Bars.Count;
            var values = new double[count];
            for (int i = 0; i < count; i++)
            {
                double delta = 0;
                
                int k = 0;
                foreach (var trade in source.GetTrades(i))
                {
                k += 1;
                }
                
                var trades = new double [k]; 
                var quantity = new double [k];
                k = 0;
                foreach (var trade in source.GetTrades(i)) 
                {
                trades[k] = trade.Price;
                quantity[k] = trade.QuantityInLots;
                k += 1;
                }
                
                for (int j = 1; j < k; j++)
                {
                		if (trades[j] > trades[j-1])
                			delta += quantity[j];
                		else if (trades[j] < trades[j-1])
                			delta -= quantity[j];
                }
                
                values[i] = delta;
            }
            
            return values;
        }
    }	
}